﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Shared;
using System.Threading;
using CMDLL = ComiLib.CMM.SafeNativeMethods;

namespace ExtListMotion
{
    public partial class ExtListMotion : Form
    {
        private int START_POS_X = 0;
        private int LM_MAP_IDX = 0;
        private int IX_MAP_IDX = 0;
        private int STATUS_BUF = 100;

        int g_nVelSpeedMultiply = 1;
        int g_nAccSpeedMultiply = 1;
        int g_dwThreadInterval = 10;

        bool g_bListMotionThreadStop = true;
        bool g_bCannotRunState = false;
        
        public ExtListMotion()
        {
            InitializeComponent();
        }

        // common function
        void InitMotionDevices()
        {
            CMDLL.cmmCfgSetSpeedRange((int)Defines._TCmAxis.cmX1, 6553500); // 6.5MPPS => Max PPS (Pulse/Sec) Setting for Axis X
            CMDLL.cmmCfgSetSpeedRange((int)Defines._TCmAxis.cmZ1, 6553500); // 6.5MPPS => Max PPS (Pulse/Sec) Setting for Axis Z

            this.txtThreadIntv.Text = "100";
        }

        void ExtListMotionMain()
        {
            int nResult = 0;
            int nSeqId = 0;
            int nStaIsBusy = 0;

            int[] axList = new int[2];
            axList[0] = (int)Defines._TCmAxis.cmX1;
            axList[1] = (int)Defines._TCmAxis.cmZ1;

            double[] afDist = new double[2];

            // step 1. Move To Position (1)
            afDist[0] = START_POS_X;
            afDist[1] = 0;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 0);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 0);
            CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            // step 2. (1) -> (2) Move
            afDist[0] = START_POS_X;
            afDist[1] = -500;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 1);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 0);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            while(true)
            {
                CMDLL.cmmLmxGetSts(LM_MAP_IDX, (int)Defines._TCmLmxStsId.cmLMX_RUN_ITEM_ID, ref nSeqId);
                CMDLL.cmmLmxGetSts(LM_MAP_IDX, (int)Defines._TCmLmxStsId.cmLMX_BUSY, ref nStaIsBusy);
                if (nSeqId == 1 && nStaIsBusy == 0)
                {
                    break;
                }
                if (g_bListMotionThreadStop)
                {
                    return;
                }
            }

            // step 3. Pick-Up Delay, 50ms
            Thread.Sleep(50); // with 1mm/sec Vel, 0.05sec Acc Time and 0.05sec Dec Time

            // step 4. (2) -> (1) Move
            afDist[0] = START_POS_X;
            afDist[1] = 0;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 2);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 0);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            // step 5. (1) -> (4) Move
            afDist[0] = START_POS_X + 1200;
            afDist[1] = 500;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 3);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 0);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            // step 6. (4) -> (5) Move
            afDist[0] = START_POS_X + 1500;
            afDist[1] = 500;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 4);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 100);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            // step 7. Place on Tray, (5) -> (6) Move
            afDist[0] = START_POS_X + 1500;
            afDist[1] = 500 - 5;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 5);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 0);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            while (true)
            {
                CMDLL.cmmLmxGetSts(LM_MAP_IDX, (int)Defines._TCmLmxStsId.cmLMX_RUN_ITEM_ID, ref nSeqId);
                CMDLL.cmmLmxGetSts(LM_MAP_IDX, (int)Defines._TCmLmxStsId.cmLMX_BUSY, ref nStaIsBusy);
                if (nSeqId == 5 && nStaIsBusy == 0)
                {
                    break;
                }
                if (g_bListMotionThreadStop)
                {
                    return;
                }
            }

            // step 8. Place-Down Delay, 80ms
            Thread.Sleep(50); // with 1mm/sec Vel, 0.08sec Acc Time and 0.08sec Dec Time

            // step 9. (6) -> (5) Move
            afDist[0] = START_POS_X + 1500;
            afDist[1] = 500;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 6);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            // step 10. (5) -> (4) Move
            afDist[0] = START_POS_X + 1200;
            afDist[1] = 500;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 7);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 100, g_nAccSpeedMultiply * 0);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);

            // step 11. (4) -> (1) Move
            afDist[0] = START_POS_X;
            afDist[1] = 0;
            CMDLL.cmmLmxSetNextItemId(LM_MAP_IDX, 8);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, g_nVelSpeedMultiply * 100, g_nAccSpeedMultiply * 0, g_nAccSpeedMultiply * 0);
            nResult = CMDLL.cmmIxLineTo(IX_MAP_IDX, afDist, (int)Defines._TCmBool.cmTRUE);
        }

        private void ExtListMotion_Load(object sender, EventArgs e)
        {
            // Load Motion & DIO devices //
            int nNumAxes=0;
            if (CMDLL.cmmGnDeviceLoad((int)Defines._TCmBool.cmTRUE, ref nNumAxes) != Defines.cmERR_NONE)
            {
                CMDLL.cmmErrShowLast(this.Handle); // 에러 발생하였으면 에러 디스플레이합니다.
                return;
            }
            else
            {
                // Motion 환경 초기화 //
                InitMotionDevices();

                // ALM Logic X축
                this.cmbAlmLogicX.SelectedIndex = 0;
                cmbAlmLogicX_SelectedIndexChanged(null, null);

                // ALM Logic Z축
                this.cmbAlmLogicZ.SelectedIndex = 0;
                cmbAlmLogicZ_SelectedIndexChanged(null, null);

                // Limit Logic X축
                this.cmbLimitLogicX.SelectedIndex = 0;
                cmbLimitLogicX_SelectedIndexChanged(null, null);

                // Limit Logic Z축
                this.cmbLimitLogicZ.SelectedIndex = 0;
                cmbLimitLogicZ_SelectedIndexChanged(null, null);

                // Command Output Mode X축
                this.cmbCmdOutModeX.SelectedIndex = 4;
                cmbCmdOutModeX_SelectedIndexChanged(null, null);

                // Command Output Mode Z축
                this.cmbCmdOutModeZ.SelectedIndex = 4;
                cmbCmdOutModeZ_SelectedIndexChanged(null, null);

                // Feedback Input Mode X축
                this.cmbFeedInModeX.SelectedIndex = 0;
                cmbFeedInModeX_SelectedIndexChanged(null, null);

                // Feedback Input Mode Z축
                this.cmbFeedInModeZ.SelectedIndex = 0;
                cmbFeedInModeZ_SelectedIndexChanged(null, null);

                this.trbVelRatio.SetRange(1, 10);
                this.trbAccRatio.SetRange(1, 10);

                // Set timer to read and display current command position //
                this.timer1.Start();
            }
        }

        private void cmbAlmLogicX_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nLogic = this.cmbAlmLogicX.SelectedIndex;

            CMDLL.cmmCfgSetMioProperty((int)Defines._TCmAxis.cmX1, (int)Defines._TCmMioPropIdEx.cmMPID_ALM_LOGIC, nLogic);
        }

        private void cmbAlmLogicZ_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nLogic = this.cmbAlmLogicZ.SelectedIndex;

            CMDLL.cmmCfgSetMioProperty((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmMioPropIdEx.cmMPID_ALM_LOGIC, nLogic);
        }

        private void cmbLimitLogicX_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nLogic = this.cmbLimitLogicX.SelectedIndex;

            CMDLL.cmmCfgSetMioProperty((int)Defines._TCmAxis.cmX1, (int)Defines._TCmMioPropIdEx.cmMPID_EL_LOGIC, nLogic);
        }

        private void cmbLimitLogicZ_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nLogic = this.cmbAlmLogicZ.SelectedIndex;

            CMDLL.cmmCfgSetMioProperty((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmMioPropIdEx.cmMPID_EL_LOGIC, nLogic);
        }

        private void cmbCmdOutModeX_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nOutputMode = this.cmbCmdOutModeX.SelectedIndex;

            CMDLL.cmmCfgSetOutMode((int)Defines._TCmAxis.cmX1, nOutputMode);
        }

        private void cmbCmdOutModeZ_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nOutputMode = this.cmbCmdOutModeZ.SelectedIndex;

            CMDLL.cmmCfgSetOutMode((int)Defines._TCmAxis.cmZ1, nOutputMode);
        }

        private void cmbFeedInModeX_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nInputMode = this.cmbFeedInModeX.SelectedIndex;

            CMDLL.cmmCfgSetInMode((int)Defines._TCmAxis.cmX1, nInputMode, (int)Defines._TCmBool.cmFALSE);
        }

        private void cmbFeedInModeZ_SelectedIndexChanged(object sender, EventArgs e)
        {
            int nInputMode = this.cmbFeedInModeZ.SelectedIndex;

            CMDLL.cmmCfgSetInMode((int)Defines._TCmAxis.cmZ1, nInputMode, (int)Defines._TCmBool.cmFALSE);
        }

        private void btnResetPos_Click(object sender, EventArgs e)
        {
            CMDLL.cmmStSetPosition((int)Defines._TCmAxis.cmX1, (int)Defines._TCmCntr.cmCNT_COMM, 0.0);
            CMDLL.cmmStSetPosition((int)Defines._TCmAxis.cmX1, (int)Defines._TCmCntr.cmCNT_FEED, 0.0);
            CMDLL.cmmStSetPosition((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmCntr.cmCNT_COMM, 0.0);
            CMDLL.cmmStSetPosition((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmCntr.cmCNT_FEED, 0.0);
        }

        private void chkServoOnX_CheckedChanged(object sender, EventArgs e)
        {
            int nChkBox = 0;

            if (this.chkServoOnX.Checked)
            {
                nChkBox = 1;
            }

            CMDLL.cmmGnSetServoOn((int)Defines._TCmAxis.cmX1, nChkBox);
        }

        private void chkServoOnY_CheckedChanged(object sender, EventArgs e)
        {
            int nChkBox = 0;

            if (this.chkServoOnZ.Checked)
            {
                nChkBox = 1;
            }

            CMDLL.cmmGnSetServoOn((int)Defines._TCmAxis.cmZ1, nChkBox);
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            g_bListMotionThreadStop = true;
            CMDLL.cmmLmxEnd(LM_MAP_IDX);
            CMDLL.cmmSxStop((int)Defines._TCmAxis.cmX1, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmBool.cmFALSE);
            CMDLL.cmmSxStop((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmBool.cmFALSE);

            this.cmbAlmLogicX.Enabled = true;
            this.cmbAlmLogicZ.Enabled = true;
            this.cmbLimitLogicX.Enabled = true;
            this.cmbLimitLogicZ.Enabled = true;
            this.cmbCmdOutModeX.Enabled = true;
            this.cmbCmdOutModeZ.Enabled = true;
            this.cmbFeedInModeX.Enabled = true;
            this.cmbFeedInModeZ.Enabled = true;

            this.btnStart.Enabled = true;
            this.btnHome.Enabled = true;
        }

        private void btnEmgStop_Click(object sender, EventArgs e)
        {
            CMDLL.cmmSxStopEmg((int)Defines._TCmAxis.cmX1);
            CMDLL.cmmSxStopEmg((int)Defines._TCmAxis.cmZ1);
        }

        /***********************************************************************
        * OnBtnStart() : "Start" Button's event handler
        * 여기서는 아래 그림과 같이 3-STEP 으로 가속했다가 3-STEP으로 감속하는 
        * 단축 이송 작업을 수행합니다. 각 스텝사이에 지연시간이 없어야지만 
        * 속도의 연속성을 확보할 수 있으므로 리스트 모션을 사용합니다.
        ***********************************************************************/
        private void btnStart_Click(object sender, EventArgs e)
        {
            this.cmbAlmLogicX.Enabled = false;
            this.cmbAlmLogicZ.Enabled = false;
            this.cmbLimitLogicX.Enabled = false;
            this.cmbLimitLogicZ.Enabled = false;
            this.cmbCmdOutModeX.Enabled = false;
            this.cmbCmdOutModeZ.Enabled = false;
            this.cmbFeedInModeX.Enabled = false;
            this.cmbFeedInModeZ.Enabled = false;

            this.btnStart.Enabled = false;
            this.btnHome.Enabled = false;

            g_bListMotionThreadStop = false;

            // Thread Move Start
            new Thread(new ThreadStart(ThfuncListMotion)).Start();
        }

        private void btnHome_Click(object sender, EventArgs e)
        {
            // Thread Homming Start
            new Thread(new ThreadStart(ThFuncHomming)).Start();
        }

        private void btnIntvApply_Click(object sender, EventArgs e)
        {
            string sTemp = this.txtThreadIntv.Text;
            int nIntv = 0;
            if(sTemp.CompareTo("") == 0)
            {
                nIntv = 100;
            }
            else
            {
                nIntv = int.Parse(sTemp);
            }

            g_dwThreadInterval = nIntv;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // Get current command position of specified axis //
            byte[] sStatus = new byte[STATUS_BUF];  // byte => int 변경
            string sStatusOut;
            int nCheckMio = 0;
            int nSeqId = 0;
            int nCurXCntCmd = 0, nCurXCntFeed = 0, nCurZCntCmd = 0, nCurZCntFeed = 0;
            int nMioStatesX = 0, nMioStatesZ = 0, nMotStatesX = 0, nMotStatesZ = 0;
            double fCurXSpdCmd = 0, fCurXSpdFeed = 0, fCurZSpdCmd = 0, fCurZSpdFeed = 0;

            // speed x multiply value
            g_nVelSpeedMultiply = this.trbVelRatio.Value;
            g_nAccSpeedMultiply = this.trbAccRatio.Value;

            // Machine I/O Status
            CMDLL.cmmStReadMioStatuses((int)Defines._TCmAxis.cmX1, ref nMioStatesX);
            CMDLL.cmmStReadMioStatuses((int)Defines._TCmAxis.cmZ1, ref nMioStatesZ);

            g_bCannotRunState = false; // initialize

            nCheckMio = (nMioStatesX >> (int)Defines._TCmMioState.cmIOST_ALM) & 1;
            if (nCheckMio == 1)
            {
                this.chkALM_X.Checked = true;
                g_bCannotRunState = true;
            }
            else
            {
                this.chkALM_X.Checked = false;
                g_bCannotRunState = false;
            }

            nCheckMio = (nMioStatesZ >> (int)Defines._TCmMioState.cmIOST_ALM) & 1;
            if (nCheckMio == 1)
            {
                this.chkALM_Z.Checked = true;
                g_bCannotRunState = true;
            }
            else
            {
                this.chkALM_Z.Checked = false;
                g_bCannotRunState = false;
            }

            nCheckMio = (nMioStatesX >> (int)Defines._TCmMioState.cmIOST_ELN) & 1;
            if (nCheckMio == 1)
            {
                this.chkELN_X.Checked = true;
                g_bCannotRunState = true;
            }
            else
            {
                this.chkELN_X.Checked = false;
                g_bCannotRunState = false;
            }

            nCheckMio = (nMioStatesZ >> (int)Defines._TCmMioState.cmIOST_ELN) & 1;
            if (nCheckMio == 1)
            {
                this.chkELN_Z.Checked = true;
                g_bCannotRunState = true;
            }
            else
            {
                this.chkELN_Z.Checked = false;
                g_bCannotRunState = false;
            }

            nCheckMio = (nMioStatesX >> (int)Defines._TCmMioState.cmIOST_ELP) & 1;
            if (nCheckMio == 1)
            {
                this.chkELP_X.Checked = true;
                g_bCannotRunState = true;
            }
            else
            {
                this.chkELP_X.Checked = false;
                g_bCannotRunState = false;
            }

            nCheckMio = (nMioStatesZ >> (int)Defines._TCmMioState.cmIOST_ELP) & 1;
            if (nCheckMio == 1)
            {
                this.chkELP_Z.Checked = true;
                g_bCannotRunState = true;
            }
            else
            {
                this.chkELP_Z.Checked = false;
                g_bCannotRunState = false;
            }

            nCheckMio = (nMioStatesX >> (int)Defines._TCmMioState.cmIOST_DIR) & 1;
            if (nCheckMio == 1)
            {
                this.chkDIR_X.Checked = true;
            }
            else
            {
                this.chkDIR_X.Checked = false;
            }

            nCheckMio = (nMioStatesZ >> (int)Defines._TCmMioState.cmIOST_DIR) & 1;
            if (nCheckMio == 1)
            {
                this.chkDIR_Z.Checked = true;
            }
            else
            {
                this.chkDIR_Z.Checked = false;
            }

            nCheckMio = (nMioStatesX >> (int)Defines._TCmMioState.cmIOST_RDY) & 1;
            if (nCheckMio == 1)
            {
                this.chkRDY_X.Checked = true;
            }
            else
            {
                this.chkRDY_X.Checked = false;
            }

            nCheckMio = (nMioStatesZ >> (int)Defines._TCmMioState.cmIOST_RDY) & 1;
            if (nCheckMio == 1)
            {
                this.chkRDY_Z.Checked = true;
            }
            else
            {
                this.chkRDY_Z.Checked = false;
            }

            nCheckMio = (nMioStatesX >> (int)Defines._TCmMioState.cmIOST_ORG) & 1;
            if (nCheckMio == 1)
            {
                this.chkORG_X.Checked = true;
            }
            else
            {
                this.chkORG_X.Checked = false;
            }

            nCheckMio = (nMioStatesZ >> (int)Defines._TCmMioState.cmIOST_ORG) & 1;
            if (nCheckMio == 1)
            {
                this.chkORG_Z.Checked = true;
            }
            else
            {
                this.chkORG_Z.Checked = false;
            }

            if (g_bCannotRunState)
            {
                this.txtStatus.Text = "Cannot Run List Motion. Check Servo Alarm or Limit Signal";
                g_bListMotionThreadStop = true;
            }
            else
            {
                this.txtStatus.Text = "Ready";
            }

            // Motion Status
            CMDLL.cmmStReadMotionState((int)Defines._TCmAxis.cmX1, ref nMotStatesX);
            CMDLL.cmmStReadMotionState((int)Defines._TCmAxis.cmZ1, ref nMotStatesZ);

            CMDLL.cmmStGetMstString(nMotStatesX, sStatus, STATUS_BUF);
            sStatusOut = "";
            for (int j = 0; j < sStatus.Length; j++)
            {
                sStatusOut += Convert.ToChar(sStatus[j]);
            }
            this.lblMotStatesX.Text = sStatusOut;

            CMDLL.cmmStGetMstString(nMotStatesZ, sStatus, STATUS_BUF);
            sStatusOut = "";
            for (int j = 0; j < sStatus.Length; j++)
            {
                sStatusOut += Convert.ToChar(sStatus[j]);
            }
            this.lblMotStatesZ.Text = sStatusOut;

            CMDLL.cmmStGetCount((int)Defines._TCmAxis.cmX1, (int)Defines._TCmCntr.cmCNT_COMM, ref nCurXCntCmd);
            CMDLL.cmmStGetCount((int)Defines._TCmAxis.cmX1, (int)Defines._TCmCntr.cmCNT_FEED, ref nCurXCntFeed);

            CMDLL.cmmStGetSpeed((int)Defines._TCmAxis.cmX1, (int)Defines._TCmCntr.cmCNT_COMM, ref fCurXSpdCmd); // mm/sec
            CMDLL.cmmStGetSpeed((int)Defines._TCmAxis.cmX1, (int)Defines._TCmCntr.cmCNT_FEED, ref fCurXSpdFeed); // mm/sec

            CMDLL.cmmStGetCount((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmCntr.cmCNT_COMM, ref nCurZCntCmd);
            CMDLL.cmmStGetCount((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmCntr.cmCNT_FEED, ref nCurZCntFeed);

            CMDLL.cmmStGetSpeed((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmCntr.cmCNT_COMM, ref fCurZSpdCmd); // mm/sec
            CMDLL.cmmStGetSpeed((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmCntr.cmCNT_FEED, ref fCurZSpdFeed); // mm/sec

            this.lblXPosCmd.Text = nCurXCntCmd.ToString();
            this.lblZPosCmd.Text = nCurZCntCmd.ToString();
            this.lblXPosFeed.Text = nCurXCntFeed.ToString();
            this.lblZPosFeed.Text = nCurZCntFeed.ToString();

            this.lblXSpeedCmd.Text = fCurXSpdCmd.ToString();
            this.lblZSpeedCmd.Text = fCurZSpdCmd.ToString();
            this.lblXSpeedFeed.Text = fCurXSpdFeed.ToString();
            this.lblZSpeedFeed.Text = fCurZSpdFeed.ToString();

            CMDLL.cmmLmxGetSts(LM_MAP_IDX, (int)Defines._TCmLmxStsId.cmLMX_RUN_ITEM_ID, ref nSeqId);
            if (nSeqId < 0)
            {
                return;
            }
            this.lblSeqIdx.Text = nSeqId.ToString();
        }

        void ThFuncHomming()
        {
            CMDLL.cmmHomeSetConfig((int)Defines._TCmAxis.cmX1, 1, 0, 1000, 0);
            CMDLL.cmmHomeSetConfig((int)Defines._TCmAxis.cmZ1, 1, 0, 1000, 0);
            CMDLL.cmmHomeSetSpeedPattern((int)Defines._TCmAxis.cmX1, (int)Defines._TCmSpeedMode.cmSMODE_T, 500, 500, 500, 250);
            CMDLL.cmmHomeSetSpeedPattern((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmSpeedMode.cmSMODE_T, 100, 100, 100, 50);

            CMDLL.cmmHomeMoveStart((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmDir.cmDIR_N);
            CMDLL.cmmHomeMoveStart((int)Defines._TCmAxis.cmX1, (int)Defines._TCmDir.cmDIR_N);

            CMDLL.cmmHomeWaitDone((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmBool.cmFALSE);
            CMDLL.cmmHomeWaitDone((int)Defines._TCmAxis.cmX1, (int)Defines._TCmBool.cmFALSE);
        }

        void ThfuncListMotion()
        {
            int nResult = 0;
            int nVal = 0;

            // Extend List Motion Starts
            CMDLL.cmmCfgGetMioProperty((int)Defines._TCmAxis.cmX1, (int)Defines._TCmMioPropIdEx.cmMPID_INP_EN, ref nVal);
            if (nVal == 1) // do not enable INP signal during List Motion
            {
                CMDLL.cmmCfgSetMioProperty((int)Defines._TCmAxis.cmX1, (int)Defines._TCmMioPropIdEx.cmMPID_INP_EN, 0);
            }

            CMDLL.cmmCfgGetMioProperty((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmMioPropIdEx.cmMPID_INP_EN, ref nVal);
            if (nVal == 1) // do not enable INP signal during List Motion
            {
                CMDLL.cmmCfgSetMioProperty((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmMioPropIdEx.cmMPID_INP_EN, 0);
            }

            nResult = CMDLL.cmmLmxStart(LM_MAP_IDX, 0x5, 0x0); // Axis-X and Axis-Z
            nResult = CMDLL.cmmLmxSetSeqMode(LM_MAP_IDX, (int)Defines._TCmLmxSeqMode.cmLMX_SEQM_WAIT_RUN);

            CMDLL.cmmIxMapAxes(IX_MAP_IDX, 0x5, 0x0);
            CMDLL.cmmCfgSetSpeedPattern((int)Defines._TCmAxis.cmX1, (int)Defines._TCmSpeedMode.cmSMODE_T, 2000, 20000, 20000);
            CMDLL.cmmCfgSetSpeedPattern((int)Defines._TCmAxis.cmZ1, (int)Defines._TCmSpeedMode.cmSMODE_T, 1000, 10000, 10000);
            nResult = CMDLL.cmmIxSetSpeedPattern(IX_MAP_IDX, (int)Defines._TCmBool.cmFALSE, (int)Defines._TCmSpeedMode.cmSMODE_T, 100, 100, 100);
            while(!g_bListMotionThreadStop)
            {
                if(!g_bCannotRunState)
                {
                    ExtListMotionMain();
                }
                Thread.Sleep(g_dwThreadInterval);
            }

            // Extend List Motion Ends
            nResult = CMDLL.cmmLmxEnd(LM_MAP_IDX);
        }

        private void ExtListMotion_FormClosing(object sender, FormClosingEventArgs e)
        {
            if(!g_bListMotionThreadStop)
            {
                btnStop_Click(null, null);
                Thread.Sleep(500); // wait some time until all thread terminated.
            }

            // 사용중인 타이머 종료.
            timer1.Stop();

            CMDLL.cmmGnDeviceUnload(); // Unload Device
        }
    }
}
