﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Shared;
using CMDLL = ComiLib.CMM.SafeNativeMethods;

namespace OverridePosition
{
    public partial class SpeedSettingForm : Form
    {
        private static int nSetCh = 0;
        private static int nSpeedMode = (int)Defines.SPDMODE.MODE_SCURVE;
        private static double fMaxSpeed = 0;
        private static double fInitSpeed = 0;
        private static double fWorkSpeed = 0;
        private static double fAcceleration = 0;
        private static double fDeceleration = 0;

        public static int SETCH
        {
            get { return nSetCh; }
            set { nSetCh = value; }
        }

        public static int SPEEDMODE
        {
            get { return nSpeedMode; }
            set { nSpeedMode = value; }
        }

        public static double MAXSPEED
        {
            get { return fMaxSpeed; }
            set { fMaxSpeed = value; }
        }

        public static double INITSPEED
        {
            get { return fInitSpeed; }
            set { fInitSpeed = value; }
        }

        public static double WORKSPEED
        {
            get { return fWorkSpeed; }
            set { fWorkSpeed = value; }
        }

        public static double ACCELERATION
        {
            get { return fAcceleration; }
            set { fAcceleration = value; }
        }

        public static double DECELERATION
        {
            get { return fDeceleration; }
            set { fDeceleration = value; }
        }

        public SpeedSettingForm(int nSelCh)
        {
            SETCH = nSelCh;
            
            InitializeComponent();
        }

        private void SpeedSettingForm_Load(object sender, EventArgs e)
        {
            CMDLL.cmmCfgGetSpeedRange(SETCH, ref fMaxSpeed, ref fMaxSpeed);
            MAXSPEED = fMaxSpeed;
            
            CMDLL.cmmSxOptGetIniSpeed(SETCH, ref fInitSpeed);
            INITSPEED = fInitSpeed;

            CMDLL.cmmCfgGetSpeedPattern(SETCH, ref nSpeedMode, ref fWorkSpeed, ref fAcceleration, ref fDeceleration);
            SPEEDMODE = nSpeedMode;
            WORKSPEED = fWorkSpeed;
            ACCELERATION = fAcceleration;
            DECELERATION = fDeceleration;

            this.cmbSpeedMode.SelectedIndex = SPEEDMODE;
            this.txtInitSpeed.Text = INITSPEED.ToString();
            this.txtWorkSpeed.Text = WORKSPEED.ToString();
            this.txtAcc.Text = ACCELERATION.ToString();
            this.txtDec.Text = DECELERATION.ToString();

            // 속도 단위 스트링 표시 //
            byte[] aszSpeedUnit = new byte[Defines.CMM_MAX_STR_LEN_VEL_UNIT];

            CMDLL.cmmAdvGetString(SETCH, (int)Defines._TCmStringID.cmSTR_SPEED_UNIT, aszSpeedUnit);

            string sAccUnit = "";
            for (int j = 0; j < aszSpeedUnit.Length; j++)
            {
                sAccUnit += Convert.ToChar(aszSpeedUnit[j]);
            }

            this.lblUnit1.Text = sAccUnit;
            this.lblUnit2.Text = sAccUnit;
            this.lblUnit3.Text = sAccUnit;
            this.lblUnit4.Text = sAccUnit;
        }

        private void cmbSpeedMode_SelectedIndexChanged(object sender, EventArgs e)
        {
            SPEEDMODE = cmbSpeedMode.SelectedIndex;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            MAXSPEED = Convert.ToDouble(txtMaxSpeed.Text);
        }

        private void txtInitSpeed_TextChanged(object sender, EventArgs e)
        {
            INITSPEED = Convert.ToDouble(txtInitSpeed.Text);
        }

        private void txtWorkSpeed_TextChanged(object sender, EventArgs e)
        {
            WORKSPEED = Convert.ToDouble(txtWorkSpeed.Text);
        }

        private void txtAcc_TextChanged(object sender, EventArgs e)
        {
            ACCELERATION = Convert.ToDouble(txtAcc.Text);
        }

        private void txtDec_TextChanged(object sender, EventArgs e)
        {
            DECELERATION = Convert.ToDouble(txtDec.Text);
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            CMDLL.cmmCfgSetSpeedRange(SETCH, MAXSPEED);
            CMDLL.cmmSxOptSetIniSpeed(SETCH, INITSPEED);
            CMDLL.cmmCfgSetSpeedPattern(SETCH, SPEEDMODE, WORKSPEED, ACCELERATION, DECELERATION);
        }
    }
}
